#include <AT89x51.H>		//
#include <intrins.h>
#define uchar unsigned char 
#define  RX  P2_0 //echo 
#define  TX  P2_1 //trig
#define LCM_RW  P2_6 //LCD
#define LCM_RS  P2_5
#define LCM_E   P2_7
#define LCM_Data  P0
#define Busy    0x80 //LCMBusy

#define led1 P1_4   //LEDLED
#define led2 P1_2   //LEDLED
#define buzzer P2_2 //

#define dianji P1_7 //I/O
#define ctrkey P3_6 //
#define ctrkey2 P3_7 

void LCMInit(void);//LCD
void DisplayOneChar(unsigned char X, unsigned char Y, unsigned char DData);//LCD
void DisplayListChar(unsigned char X, unsigned char Y, unsigned char code *DData);//LCD
void Delay5Ms(void);//5
void Delay400Ms(void);//400
void Decode(unsigned char ScanCode);
void WriteDataLCM(unsigned char WDLCM);//LCD1602
void WriteCommandLCM(unsigned char WCLCM,BuysC);//LCD

unsigned char num = 0,gao_num = 1,di_num = 3; //
unsigned char keyv = 0;  //

unsigned char ReadStatusLCM(void);
unsigned char code Range[] = "==RangeFinder==";
unsigned char code Rangex[5][20] = {"L=025","L=050","L=100","L=150"}; //LCD1602
unsigned char code SpeedH[] = " SpeedHigh"; //
unsigned char code SpeedL[] = " Speed_Low"; //
unsigned char code ASCII[13] = "0123456789.-M";
unsigned char code table[]="Distance:000.0cm";//
unsigned char code table1[]="!!! Out of range";//
			
unsignedint  time=0;
unsigned long S=0;
unsigned int  limit=250;   //mm
bit  flag =0;
unsigned char disbuff[4]={ 0,0,0,0,};

/********************LCD************************************/
//
voidWriteDataLCM(unsigned char WDLCM) 
{
	ReadStatusLCM(); //
	LCM_Data = WDLCM;
	LCM_RS = 1;
	LCM_RW = 0;
	LCM_E = 0; 
	LCM_E = 0; //
	LCM_E = 1;
}

//
void WriteCommandLCM(unsigned char WCLCM,BuysC) //BuysC0
{
	if (BuysC) ReadStatusLCM(); //
	LCM_Data = WCLCM;
	LCM_RS = 0;
	LCM_RW = 0;	
	LCM_E = 0;
	LCM_E = 0;
	LCM_E = 1;	
}

//
unsigned char ReadStatusLCM(void)
{
	LCM_Data = 0xFF; 
	LCM_RS = 0;
	LCM_RW = 1;
	LCM_E = 0;
	LCM_E = 0;
	LCM_E = 1;
	while (LCM_Data& Busy); //
	return(LCM_Data);
}

void LCMInit(void) //LCM
{
	LCM_Data = 0;
	WriteCommandLCM(0x38,0); //
	Delay5Ms(); 
	WriteCommandLCM(0x38,0);
	Delay5Ms(); 
	WriteCommandLCM(0x38,0);
	Delay5Ms(); 

	WriteCommandLCM(0x38,1); //,
	WriteCommandLCM(0x08,1); //
	WriteCommandLCM(0x01,1); //
	WriteCommandLCM(0x06,1); // 
	WriteCommandLCM(0x0c,1); // 
}

//
voidDisplayOneChar(unsigned char X, unsigned char Y, unsigned char DData)
{
	Y &= 0x1;
	X &= 0xF;         //X15Y1
	if (Y) X |= 0x40; //+0x40;
	X |= 0x80;        //
	WriteCommandLCM(X, 1); //
	WriteDataLCM(DData);   //
}

//
voidDisplayListChar(unsigned char X, unsigned char Y, unsigned char code *DData)
{
	unsigned char ListLength;

ListLength = 0;
	Y &= 0x1;
	X &= 0xF;                      //X15Y1
	while (DData[ListLength]>0x19) //
		{
			if (X <= 0xF)          //X0xF
				{
					DisplayOneChar(X, Y, DData[ListLength]); //
					ListLength++;
					X++;
				}
		}
}

//5ms
void Delay5Ms(void)
{
	unsignedintTempCyc = 5552;
	while(TempCyc--);
}

//400ms
void Delay400Ms(void)
{
	unsigned char TempCycA = 5;
	unsignedintTempCycB;
	while(TempCycA--)
		{
			TempCycB=7269;
			while(TempCycB--);
		};
}
/*************************************************************/
void delay(uchari)        //
{
ucharj,k;
for(j=i;j>0;j--)
for(k=125;k>0;k--);
}
void key ()                //
{
   if(ctrkey==0)		   //
   {
     delay(5);             //
	if(ctrkey == 0)
	 {
keyv ++;
if(keyv>= 4)
keyv = 3;
switch(keyv)
         {
case 0:
           limit = 250;  //25cm
break;
case 1:
           limit = 500;  //50cm
break;
case 2:
           limit = 1000; //100cm
break;
		case 3:
		   limit = 1500; //150m
break;
		 }  
		 while(ctrkey == 0);//
	 }
   }
   if(ctrkey2 == 0)		    //
   {
delay(5);
	if(ctrkey2 == 0)
	 {
		if(keyv == 0);
		else
		keyv --;
switch(keyv)
         {
case 0:
           limit = 250;  //25cm
break;
case 1:
           limit = 500;  //50cm
break;
case 2:
           limit = 1000; //100cm
break;
		case 3:
		   limit = 1500; //150m
break;
		 }  
		 while(ctrkey2 == 0);//
	 }	
   }
}

/********************************************************/

void dispose()      //
{
switch(num)
  {
case 0:
	gao_num=1;     //PWM1
	di_num=3;      //PWM3
	break;
case 1:
	gao_num=1;
	di_num=3;      //
	break;
  }
}
void qudong()       //
{
unsigned char i;
if(di_num!=0)
  {
for(i=0;i<di_num;i++)
	{
	dianji=0;      //PWM
	delay(5);   
	}
  }

for(i=0;i<gao_num;i++)
  {
dianji=1;    //PWM
	delay(5);
  }
}

/********************************************************/
voidConut(void)
	{
	 time=TH0*256+TL0;//
	 TH0=0;
	 TL0=0;	
	 S=(time*1.7)/10;         //340/2 * 1000 / 1M 1.7mm
     if(S <= limit)           //
     {
      led1 = 1;
      led2 = 0;
buzzer = 0;
num = 0;
DisplayListChar(5, 0, SpeedL);
	 }
     else                   //
     {
      led1 = 0;
      led2 = 1; 
      P3_0 = 0;//??
buzzer = 1;
num = 1;
DisplayListChar(5, 0, SpeedH);
     }
dispose();
qudong();              //
     if((S>=3000)||flag==1) //2m
	 {	
buzzer = 1;
	flag=0;
DisplayListChar(0, 0, Rangex[keyv]);
DisplayListChar(5, 0, SpeedH);
DisplayListChar(0, 1, table1);
	 }
	 else                   //
	 {
disbuff[0]=S%10;
	disbuff[1]=S/10%10;
	disbuff[2]=S/100%10;
	disbuff[3]=S/1000;
DisplayListChar(0, 0, Rangex[keyv]);
if(S <= limit)
      {
DisplayListChar(5, 0, SpeedL);
	  }
else
      {
DisplayListChar(5, 0, SpeedH);
      }
DisplayListChar(0, 1, table);
	DisplayOneChar(9, 1, ASCII[disbuff[3]]);
	DisplayOneChar(10, 1, ASCII[disbuff[2]]);	
	DisplayOneChar(11, 1, ASCII[disbuff[1]]);
DisplayOneChar(12, 1, ASCII[10]);
	DisplayOneChar(13, 1, ASCII[disbuff[0]]);
	 }
	}
/********************************************************/
void zd0() interrupt 1 		 //T0,
{                            //RX
      flag=1;			     //
	  RX=0;
}
/********************************************************/
void  StartModule() 		         //
{
	  TX=1;			                 //trig
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_();
	  _nop_(); 
	  _nop_(); 
	  _nop_(); 
	  _nop_();
	  TX=0;//
}
/********************************************************/ 
voidTimer_Count(void)
{
	TR0=1;			    //
    while(RX);			//RX1TH0,TL0flag
    TR0=0;				//RX=0
Conut();			//
}
/*********************************************************/
void main(void)
{
unsignedintvalA;
unsignedinti;
	Delay400Ms();   //LCM
	LCMInit();      //LCM
	Delay5Ms();     //
    led1 = 0;
    led2 = 0;
	buzzer = 1;
DisplayListChar(0, 0, Range);
	DisplayListChar(0, 1, table);
for(i = 0; i< 10; i ++)
    {
Delay400Ms();
    }
    TMOD=0x01;     //T01GATE=1
dianji = 0;
    EA=1;          //
    TH0 = 0;
	TL0 = 0;
    ET0=1;         //T0		
	while(1)
	  {
		RX=1;
	StartModule();//10us
dianji = 0;
for(valA=7510;valA>0;valA--)
	    {
	       if(RX==1)//
		   {
		Timer_Count();
           }
key();
        }
	  }
}